#!/usr/bin/env python

#RedToProRes.py
#Copyright 2012 Angelo Lorenzo & Michael Lorenzo
#Free to use for commercial use. May not be resold or relicensed.
#May not be republished without consent of the authors.
#http://www.fallenempiredigital.com

from os.path import getmtime, join, isfile, realpath, getsize, basename
import subprocess as subp
import os
import re
import time

### SETTINGS ###
path_to_watch = r'C:\uncompressed' #no trailing slash! This is the path that Redcine X exports its uncompressed video files
recursive = False #or True if you want
process_name = 'ffmbc.exe' #either ffmpeg.exe or ffmbc.exe, helps control how many concurrent files you can process
process_limit = 1 #number of concurrent files you can process, 1 is fine in most cases
command_string = r'C:\path\to\ffmbc.exe -threads 16 -i FILE -vcodec prores -profile lt -acodec copy "C:\path\to\prores\FNAME" & del FILE' # FILE will get replaced with actual file path, FNAME with the filename
### END SETTINGS ###

### No need to touch the rest
def listdirfiles(root_path):
	for f in os.listdir(root_path):
		file_path = join(root_path, f)
		if isfile(file_path):
			yield file_path

def fake_walk(root_path):
	for f in listdirfiles(root_path):
		yield (root_path, None, [f])

def getfiles(root_path, filter='.', recurse=True):
	root_path = realpath(root_path)
	if recurse is True:
		path_info = os.walk(root_path)
	else:
	
		path_info = fake_walk(root_path)
	for path, dirs, files in path_info:
		for f in files:
			if re.search(filter, f) is None:
				continue
			file_path = join(path, f)
			yield file_path

needs_processing = []
already_processed = []

while True:
	#add files to needs_processing if they are done being modified
	for f in getfiles(path_to_watch, recurse=recursive):
		updated = True
		msize = int(getsize(f))
		while updated == True:
				time.sleep(10)
				if int(getsize(f)) == msize:
					updated = False
				msize = int(getsize(f))
		
		if updated == False:
			needs_processing.append(f)
	
		for i, f in enumerate(needs_processing):
			if f in already_processed:
				needs_processing[i] = False
		needs_processing = filter(None, needs_processing)
		#create processes
		for f in needs_processing:
			#find number of processes
			stdout = subp.Popen('tasklist', stdout=subp.PIPE, shell=True).stdout.read()
			num_processes = len(re.findall(re.escape(process_name), stdout))
			while num_processes >= process_limit:
				time.sleep(1)
				stdout = subp.Popen('tasklist', stdout=subp.PIPE, shell=True).stdout.read()
				num_processes = len(re.findall(re.escape(process_name), stdout))
			already_processed.append(f)
			new_command_string = command_string.replace('FILE', '"' + f + '"')
			new_command_string = new_command_string.replace('FNAME', os.path.basename(f))
			subp.Popen(new_command_string, shell=True)
	time.sleep(1)